/* Datei Loesung_19_2.c */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct produkt { 
	char name [20];
	int preis;
	struct produkt * next;
};

void ausgabe (struct produkt * pointer)
{
	printf ("\nAusgabe der Produktdaten: ");
	while (pointer != NULL) 
	{
		printf ("\nDas Produkt %s kostet %d Euro",
			pointer->name, pointer->preis);
		pointer = pointer -> next;
	}
}

void freigabe(struct produkt ** pointer)
{
	if(*pointer)
	{
		freigabe(&(*pointer)->next);
		printf ("\nLoesche Produkt %s",
			(*pointer)->name);
		free(*pointer);
		*pointer = NULL;
	}
}

void ausgabe2 (struct produkt * pointer)
{
	if (pointer != NULL)
	{
		ausgabe2 (pointer->next);
		printf ("\nDas Produkt %s kostet %d Euro",
			pointer->name, pointer->preis);
	}
}

int main (void)
{
	int zahl;
	int LV;
	struct produkt * zeiger, * hilf;
	hilf = NULL;
	printf ("\n\nWieviel Produkte wollen Sie aufnehmen ?: ");
	scanf ("%d", &zahl);
   getchar();  /* '\n' aus Tataturpuffer ueberlesen */
	for (LV = 1; LV <= zahl; LV++)
	{
		zeiger = (struct produkt *) malloc (sizeof (struct produkt));
		printf ("\n\nGib den Produktnamen ein: ");
		fgets (zeiger -> name, 20, stdin);
		printf ("\nGib den Preis in Euro ein: ");
		scanf ("%d", &(zeiger->preis));
		getchar();  /* '\n' aus Tataturpuffer ueberlesen */
		
		zeiger->next = hilf;
		hilf = zeiger;
	}
	ausgabe (hilf);
	printf ("\n\njetzt wird's rekursiv");
	printf ("\nAusgabe der Produktdaten: ");
	ausgabe2 (hilf);
	freigabe(&hilf);
	return 0;
}
