#include <stdio.h>

#define ENTWICKLUNGS_VERSION

#ifdef ENTWICKLUNGS_VERSION
   #define UNTERER_GRENZWERT 1
   #define OBERER_GRENZWERT 8
#else
   #define UNTERER_GRENZWERT 2
   #define OBERER_GRENZWERT 7
#endif

#define GROESSER(x,y) (x>=y)
#define KLEINER(x,y) (x<=y)
#define IM_BEREICH(x,y,z) (GROESSER(x,y) && KLEINER(x,z))


#define GUELTIG(x) IM_BEREICH(x,UNTERER_GRENZWERT,OBERER_GRENZWERT)

int main (void)
{
   for( int i = 0; i < 10; ++i)
   {
      if (GUELTIG(i))
      {
         printf("%i",i);
      } else
      {
         printf("_");
      }
   }
   return 0;
}
